#include "Amount.h"
#include "Reader.h"
#include "Writer.h"



void Amount::acceptReader(Reader* reader)
{
	value = reader->readDouble();
}

void Amount::acceptWriter(Writer* writer) const
{
	writer->writeDouble(value);
}

const char* Amount::typeName() const
{
	return "Amount";
}

const String Amount::asString() const
{
	return String(value);
}

bool Amount::isValid() const
{
	return true;
}

bool Amount::operator==(const Amount& a)
{
	return value == a.value;
}

Amount& Amount::operator=(double d)
{
	value = d;
	return *this;
}

Amount& Amount::operator=(const Amount& a)
{
	value = a.value;
	return *this;
}

Amount& Amount::operator+=(const Amount& a)
{
	value += a.value;
	return *this;
}

Amount& Amount::operator-=(const Amount& a)
{
	value -= a.value;
	return *this;
}

Amount::Amount()
{
	value = 0.0;
}

Amount::Amount(double amount)
{
	value = amount;
}

Amount::Amount(Amount& amount)
{
	value = amount.value;
}

