#ifndef _Amount_h
#define _Amount_h



#include "Value.h"
#include "String.h"



class Amount : public Value
{
public:
	virtual void acceptReader(Reader*);
	virtual void acceptWriter(Writer*) const;
	virtual const char* typeName() const;

	virtual const String asString() const;
	virtual bool isValid() const;
	virtual bool operator==(const Amount&);
	
	virtual Amount& operator=(double);
	virtual Amount& operator=(const Amount&);
	virtual Amount& operator+=(const Amount&);
	virtual Amount& operator-=(const Amount&);
	
	Amount();
	Amount(double);
	Amount(Amount&);
	
private:
	double value;

};



#endif

