#include "Currency.h"
#include "Reader.h"
#include "Writer.h"



void Currency::acceptReader(Reader* reader)
{
	value = reader->readString();
}

void Currency::acceptWriter(Writer* writer) const
{
	writer->writeString(value);
}

const char* Currency::typeName() const
{
	return "Currency";
}

const String Currency::asString() const
{
	return value;
}

bool Currency::isValid() const
{
	return true;
}

bool Currency::operator==(const Currency& c)
{
	return value == c.value;
}

Currency& Currency::operator=(const char* p)
{
	value = p;
	return *this;
}

Currency& Currency::operator=(const Currency& c)
{
	value = c.value;
	return *this;
}

Currency::Currency() : value("CHF")
{
}

Currency::Currency(char* p) : value(p)
{
}

Currency::Currency(String& s) : value(s)
{
}

Currency::Currency(Currency& currency)
{
	value = currency.value;
}

