#ifndef _Customer_h
#define _Customer_h



#include "Object.h"
#include "String.h"

class List;
class Account;



class Customer : public Object
{
public:
	virtual void acceptReader(Reader*);
	virtual void acceptWriter(Writer*) const;
	virtual const char* typeName() const;
	
	virtual void addAccount(Account*);
	virtual void removeAccount(Account*);
	
	Customer();
	Customer(const String&, const String&);
	
private:
	String firstName;
	String lastName;
	char middleInitial;
	
	List* accounts;
};



#endif

