#include "Iterator.h"
#include "List.h"





const Object* Iterator::operator()()
{
	const Object* pItem = pList->item( pCons );
	pCons = pList->next( pCons );
	return pItem;
}


const Object* Iterator::item()
{
	return pList->item( pCons );
}


void Iterator::insert( const Object* pObject )
{
	pCons = pList->insert( pCons, pObject );
}


void Iterator::remove()
{
	if ( pCons != null ) pCons = pList->remove( pCons );
}


void Iterator::remove( const Object* pObject )
{
	Cons* pCons = pList->find( pObject );
	if ( pCons != null ) pList->remove( pCons );
	pList->drop( pCons );
}


bool Iterator::contains( const Object* pObject )
{
	Cons* pCons = pList->find( pObject );
	pList->drop( pCons );
	return pCons != null;
}


void Iterator::connect( const List& rList )
{
	pList = & ( (List&) rList );
	pCons = pList->headCons();
}


void Iterator::disconnect()
{
	pList->drop( pCons );
	pList = null;
}


Iterator::Iterator( const List& rList )
{
	connect( rList );
}


Iterator::Iterator( const List* pList )
{
	connect( *pList );
}


Iterator::~Iterator()
{
	if ( pList != null ) disconnect();
}

