#ifndef _List_H
#define _List_H



#include "Types.h"

class Cons;
class Object;



class List
{
public:
		// retrieve current item
	const Object* item( Cons* );
	const Object* first();
	const Object* last();

		// information access
	bool isEmpty() const;
	bool contains( const Object*);
	unsigned long size() const;

		// insert and remove operations
	Cons* insert( Cons*, const Object* );
	Cons* remove( Cons* );
	void removeFirst();
	void removeLast();
	void prepend( const Object* );
	void append( const Object* );
	void remove( const Object* );

		// operations for positioning
	Cons* headCons();
	Cons* tailCons();
	Cons* next( Cons* );
	Cons* previous( Cons* );
	Cons* find( const Object* );

		// working with the list
	void take( Cons* );
	void drop( Cons* );

		// ctor and dtor
	List();
	~List();

private:
		// internal positioning
	Cons* nextValid( Cons* );
	Cons* previousValid( Cons* );

		// using a linked list of cons cells
	Cons* pHead;
	Cons* pTail;
};





#endif


